#ifndef INIT_H
#define INIT_H

#define ESC_KEY 27
#define VIDEO_W		320
#define VIDEO_H		240
#define VIDEO_BIT	16

#define RAD(k) ( (k) * 3.14159265358979/180.0 ) /* 度からラジアン角に変換するマクロ */
#define BLOCKMAX 80		//ブロックの最大数
#define BALLMAX 40		//ボールの最大数

//====================================================================================================
/*
typedef struct data2
{
int wx;			//画像座標x
int wy;			//画像座標y
int width;		//幅
int height;		//高さ
int x;			//座標x
int y;			//座標y
float vx;		//ベクトルx
float vy;		//ベクトルy
float weight;	//体重
float gravity;	//重力
int flg;		//状態
int jflg;		//ジャンプ
int tang;		//角度

}
*/
//==================================================
//オブジェクトの構造体
//==================================================
typedef struct data
{
	int wx;			//画像座標x
	int wy;			//画像座標y
	int x;			//座標x
	int y;			//座標y
	float vx;		//ベクトルx
	float vy;		//ベクトルy
	float weight;	//体重
	float gravity;	//重力
	int flg;		//状態
} BLOCK, BALL;

//==================================================
//初期化に関する
//==================================================


//ゲームに関する
void GameInit(void)
{
	
}

//マウスに関する
void MouseInit(int mx, int my, int mbx, int mby)
{
	mx = 0; my = 0;
	mbx = 0; mby = 0;
	return;
}

//自機に関する
void MineInit(int flg, int jflg, int wx, int wy, int width, int height, int x, int y, float vx, float vy, float weight, float gravity)
{
	flg = 0;
	jflg = 0;
	wx = 0; wy = 0;
	width = 16; height = 32;
	x = VIDEO_W/2; y = VIDEO_H/2;
	vx = 0;	vy = 0;
	weight = 0.5; gravity = 0;
	return;
}

//弾に関する
void TamaInit(int tflg, int twx, int twy, int twidth, int theight, int tx, int ty, float tvx, float tvy, int tang)
{
	tflg = 0;
	twx = 0, twy = 0, twidth = 0, theight = 0;
	tx = 0, ty = 0;
	tvx = 0, tvy = 0;
	tang = 0;
	return;
}
//ブロックに関する
void BlockInit(BLOCK block[], int blockwidth, int blockheight)
{
	int i;
	blockwidth = 32, blockheight = 32;
	for(i = 0;i < BLOCKMAX;i++){
		block[i].wx = 64;			//画像座標x
		block[i].wy = 0;			//画像座標y
		block[i].x = -blockwidth;	//座標x
		block[i].y = -blockheight;	//座標y
		block[i].vx = 0;			//ベクトルx
		block[i].vy = 0;			//ベクトルy
		block[i].weight = 0.01;		//体重
		block[i].gravity = 0;		//重力
		block[i].flg = 0;			//状態
	}
	return;
}

//ボールに関する
void BallInit(BALL ball[], int ballwidth, int ballheight)
{
	int i;
	ballwidth = 32, ballheight = 32;
	for(i = 0;i < BALLMAX;i++){
		ball[i].wx = 96;			//画像座標x
		ball[i].wy = 0;				//画像座標y
		ball[i].x = -ballwidth;		//座標x
		ball[i].y = -ballheight;	//座標y
		ball[i].vx = 0;				//ベクトルx
		ball[i].vy = 0;				//ベクトルy
		ball[i].weight = 0.005;		//体重
		ball[i].gravity = 0;		//重力
		ball[i].flg = 0;			//状態
	}
	return;
}

#endif
/*
	mx = 0; my = 0;
	mbx = 0; mby = 0;

	flg = 0;
	jflg = 0;
	wx = 0; wy = 0;
	width = 16; height = 32;
	x = VIDEO_W/2; y = VIDEO_H/2;
	vx = 0;	vy = 0;
	weight = 0.5; gravity = 0;

	tflg = 0;
	twx = 0, twy = 0, twidth = 0, theight = 0;
	tx = 0, ty = 0;
	tvx = 0, tvy = 0;
	tang = 0;

	blockwidth = 32, blockheight = 32;
	for(bcnt = 0;bcnt < BLOCKMAX;bcnt++){
		block[bcnt].wx = 64;			//画像座標x
		block[bcnt].wy = 0;				//画像座標y
		block[bcnt].x = -blockwidth;	//座標x
		block[bcnt].y = -blockheight;	//座標y
		block[bcnt].vx = 0;				//ベクトルx
		block[bcnt].vy = 0;				//ベクトルy
		block[bcnt].weight = 0.01;		//体重
		block[bcnt].gravity = 0;		//重力
		block[bcnt].flg = 0;			//状態
	}

	ballwidth = 32, ballheight = 32;
	for(bcnt = 0;bcnt < BALLMAX;bcnt++){
		ball[bcnt].wx = 96;				//画像座標x
		ball[bcnt].wy = 0;				//画像座標y
		ball[bcnt].x = -ballwidth;		//座標x
		ball[bcnt].y = -ballheight;		//座標y
		ball[bcnt].vx = 0;				//ベクトルx
		ball[bcnt].vy = 0;				//ベクトルy
		ball[bcnt].weight = 0.005;		//体重
		ball[bcnt].gravity = 0;			//重力
		ball[bcnt].flg = 0;				//状態
	}
*/
