#ifndef JUDGE_H
#define JUDGE_H

#define BLACK 12678 //RGB(51,51,51)

//==================================================
//色に関する判定
//==================================================
//右判定
int CheckRightCollor(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //true = 判定有

	for(i = 0;i < height-1;i++){
		if( getpixel(screen,x+width,y+i) == BLACK ){ flg = 1; break;}
	}
	if(x+width >= 320) flg = 1;

	//	if( flg == 0 && getpixel(screen,x+width,y+i) == BLACK ){ flg = 2;} //上り坂用
	return flg;
}
//左判定
int CheckLeftCollor(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //true = 判定有

	for(i = 0;i < height-1;i++){
		if( getpixel(screen,x-1,y+i) == BLACK ){ flg = 1; break;}
	}
	if(x <= 0) flg = 1;

	//	if( flg == 0 && getpixel(screen,x-1,y+i) == BLACK ){ flg = 2;} //上り坂用
	return flg;
}
//下判定
int CheckDownCollor(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //true = 判定有

	for(i = 0;i < width;i++){
		if( getpixel(screen,x+i,y+height) == BLACK ){ flg = 1; break;}
	}
	if(y+height >= 240) flg = 1;
	return flg;
}
//上判定
int CheckUpCollor(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //true = 判定有

	for(i = 0;i < width;i++){
		if( getpixel(screen,x+i,y-1) == BLACK ){ flg = 1; break;}
	}
	if(y <= 0) flg = 1;
	return flg;
}


//==================================================
//斜面に関する判定(ボールのみ)
//==================================================
//上判定
int CheckUpMirror(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //－…左移動　＋…右移動

	for(i = width/2-1;i > -1;i--){
		if( getpixel(screen,x+i,y-1) == BLACK ){
			flg++;
		}
	}
	for(i = width/2;i < width;i++){
		if( getpixel(screen,x+i,y-1) == BLACK ){
			flg--;
		}
	}
	if(flg > 0) flg = 1;
	else if(flg < 0) flg = -1;

	return flg;
}
//下判定
int CheckDownMirror(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //－…左移動　＋…右移動

	for(i = width/2-1;i > -1;i--){
		if( getpixel(screen,x+i,y+height) == BLACK ){
			flg++;
		}
	}
	for(i = width/2;i < width;i++){
		if( getpixel(screen,x+i,y+height) == BLACK ){
			flg--;
		}
	}
	if(flg > 0) flg = 1;
	else if(flg < 0) flg = -1;

	return flg;
}

//==================================================
//自機とオブジェクトに関する判定
//==================================================
//□：□判定
int CheckObject(int x, int y, int width, int height, int bx, int by, int bwidth, int bheight)
{
	int flg = 0; //true = 判定有

	if(x+width > bx && x < bx+bwidth && //横判定
		y+height > by && y < by+bheight){ //縦判定
			flg = 1;
	}

	return flg;
}

//オブジェクトの下判定
int CheckObjectDown(int x, int y, int width, int height, int bx, int by, int bwidth, int bheight)
{
	int flg = 0; //true = 判定有

	if(x+width > bx && x < bx+bwidth && //横判定
		y == by+bheight-1){ //判定
			flg = 1;
	}

	return flg;
}

//==================================================
//ショット判定
//==================================================
int CheckShot(int x, int y, int bx, int by, int blockwidth, int blockheight)
{
	int flg = 0; //true = 判定有

	if(x > bx && x < bx+blockwidth && //横判定
		y > by && y < by+blockheight){ //縦判定
			flg = 1;
	}

	return flg;
}

//==================================================
//自機と天井判定
//==================================================
int CheckUp(SDL_Surface *screen, int x, int y, int width, int height)
{
	int i;
	int flg = 0; //true = 判定有

	if( y < 32 ) flg = 1;
	
	return flg;
}

#endif
