#ifndef SUPPORT_H
#define SUPPORT_H

//==================================================
//付加に関する関数
//==================================================
//体重分の重力をベクトル加算
float Gravity(float weight, float gravity)
{
	return gravity += weight;
}

//摩擦抵抗（修正必須）
void Friction(int cnt, float vx ,float weight)
{
	if(vx < 0){ //左ベクトル時
		cnt++;
		if(cnt > weight*2){
			if(vx < -5) vx += 2.0;
			else vx+=1.0;
			if(vx > 0) vx = 0;
			cnt = 0;
		}
	}else if(vx > 0){ //右ベクトル時
		cnt++;
		if(cnt > weight*2){
			if(vx > 5) vx -= 2.0;
			else vx-=1.0;
			if(vx < 0) vx = 0;
			cnt = 0;
		}
	}else{ //ベクトル無
		cnt = 0;
	}
	return;
}

//==================================================
//FPSに関する関数
//==================================================
void calcFPS(void)
{
	static Uint32 tick=0;
	static int freamcnt=0,fps=0;
	freamcnt++;
	if(tick+1000<SDL_GetTicks()){
		fps=freamcnt;
		freamcnt=0;
		tick=SDL_GetTicks();
		printf("%d fps\n",fps);
	}
	return;
}

void loopWait(void){
	Uint32 nowtime,lefttime;
	static Uint32 lasttime=0;
	const Uint32 interval=1000/40;//FPS__
	nowtime=SDL_GetTicks();
	lefttime=lasttime+interval-nowtime;
	if(lasttime+interval>nowtime){
		SDL_Delay(lefttime);
		lasttime=nowtime+lefttime;
	}else lasttime=nowtime;
	return;
}

//==================================================
//色取得に関する関数
//==================================================
int getpixel(SDL_Surface *surface, int x, int y)
{
	if(x<0||x>VIDEO_W)return 0xff;
	if(y<0||y>VIDEO_H)return 0xff;
	int bpp = surface->format->BytesPerPixel;
	/* この p は取得したいピクセルを指すアドレス */
	Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

	switch(bpp) {
			case 1:
				return *p;

			case 2:
				return *(Uint16 *)p;
			case 3:
				if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
					return p[0] << 16 | p[1] << 8 | p[2];
				else
					return p[0] | p[1] << 8 | p[2] << 16;

			case 4:
				return *(Uint32 *)p;

			default:
				return 0;       /* 起こるはずがないが、ワーニングを回避 */
	}
}

#endif
